#ifndef DMLITE_DSI_INTERNAL_H
#define DMLITE_DSI_INTERNAL_H

#include "dmlite_gridftp.h"

#include <errno.h>
#include <stdarg.h>
#include <sys/stat.h>

#include <dmlite/c/any.h>
#include <dmlite/c/catalog.h>
#include <dmlite/c/pool.h>
#include <dmlite/c/io.h>

/* Logging and error handling functions */
void dmlite_gfs_log(dmlite_handle_t * handle, globus_gfs_log_type_t type, char * format, ...);

globus_result_t dmlite_error2gfs_result(const char * name, dmlite_handle_t * handle, struct dmlite_context * context);

globus_result_t posix_error2gfs_result(const char * name, dmlite_handle_t * handle, int errnum, char * format, ...);

/* Utility functions used by several commands */
void dmlite_gfs_hostid2host(char * host_id, char * host);

const char * dmlite_gfs_fixpath(const char * path, globus_bool_t hostname);

void dmlite_stat2gfs(char * name, struct stat * stat, globus_gfs_stat_t * gfs_stat);

struct dmlite_context * dmlite_get_context(dmlite_handle_t * dmlite_handle);

dmlite_fd * dmlite_gfs_open(struct dmlite_context * dmlite_context_obj, dmlite_handle_t * dmlite_handle_obj, const char * path, int flags);

int dmlite_gfs_close(struct dmlite_context * dmlite_context_obj, dmlite_handle_t * dmlite_handle_obj, globus_bool_t ok);

#endif /* DMLITE_DSI_INTERNAL_H */
